########## S script: sec.3.1.s ##########

# S-PLUS code listed in Section 3.1 of
# the paper "Smoothing and Mixed Model Software"
# by Ngo & Wand.


default.knots <- function(x,num.knots)
{
   if (missing(num.knots))
      num.knots <- max(5,min(floor(length(unique(x))/4),35))

   return(quantile(unique(x),seq(0,1,length=
                  (num.knots+2))[-c(1,(num.knots+2))]))
}

########## End of sec.3.1.s ##########